#include "cmnAes.h"
#include <exception>

namespace utils
{
    CAes::CAes()
    {
        init_ctr();
    }
    //-------------------------------------------------------------------------------------------------------------
    void 
    CAes::init_ctr()
    {
        /* aes_ctr128_encrypt requires 'num' and 'ecount' set to zero on the
         * first call. */
        state.num = 0;
        memset(state.ecount, 0, AES_BLOCK_SIZE);

        /* Copy IV into 'ivec' */
        //RtlCopyMemory(state->ivec, iv, AES_BLOCK_SIZE);
        memset(state.ivec, 0, AES_BLOCK_SIZE);
    }
    //------------------------------------------------------------------------------------------------------------
    void 
    InitializeAesKey ( const unsigned char* aKey, unsigned int KeyLength, CSecurityKey* key )
    {
        AES_KEY bfKey;
        ::memset( &bfKey, 0, sizeof (bfKey) );

        if ( AES_set_encrypt_key( aKey, KeyLength, &bfKey ) < 0 )
            throw std::exception ( "Error on AES_set_encrypt_key" );

        *key = CSecurityKey ( (char*)&bfKey, sizeof(AES_KEY));
    }
    //------------------------------------------------------------------------------------------------------------
    void CAes::EncryptECB ( const char* pvBufferIn, char* pvBufferOut, unsigned long dwLength, CSecurityKey* key )
    {
        AES_ctr128_encrypt(
            (const unsigned char*)pvBufferIn,
            (unsigned char*)pvBufferOut,
            dwLength,
            (AES_KEY*)&key->getKey().front(),
            state.ivec,
            state.ecount,
            &state.num);
    }
    //------------------------------------------------------------------------------------------------------------
    void CAes::DecryptECB ( const char* pvBufferIn, char* pvBufferOut, unsigned long dwLength, CSecurityKey* key)
    {
        AES_ctr128_encrypt((const unsigned char*)pvBufferIn,
            (unsigned char*)pvBufferOut,
            dwLength,
            (AES_KEY*)&key->getKey().front(),
            state.ivec,
            state.ecount,
            &state.num);
    }
    //------------------------------------------------------------------------------------------------------------
}