#ifndef __CMN_EXCEPTION__
#define __CMN_EXCEPTION__

#include <Windows.h>
#include <sstream>

namespace utils
{
    //-----------------------------------------------------------------------------
    //String builders
    //-----------------------------------------------------------------------------
    template<class charType>
    struct builder
    {
        typedef std::basic_stringstream<charType> used_stringstream;
        typedef std::basic_string<charType> used_string;

    private:
        used_stringstream stream;

        builder(const builder&);
        builder& operator = (const builder&);
    public:

        operator used_string() const
        {
            return stream.str();
        }

        template<class T1>
        builder(T1 p1)
        {
            stream << p1;
        }
        template<class T1, class T2>
        builder(T1 p1, T2 p2)
        {
            stream << p1 << p2;
        }
        template<class T1, class T2, class T3>
        builder(T1 p1, T2 p2, T3 p3)
        {
            stream << p1 << p2 << p3;
        }
        template<class T1, class T2, class T3, class T4>
        builder(T1 p1, T2 p2, T3 p3, T4 p4)
        {
            stream << p1 << p2 << p3 << p4;
        }

        template<class T1, class T2, class T3, class T4, class T5>
        builder(T1 p1, T2 p2, T3 p3, T4 p4, T5 p5)
        {
            stream << p1 << p2 << p3 << p4 << p5;
        }

        template<class T1, class T2, class T3, class T4, class T5, class T6>
        builder(T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6)
        {
            stream << p1 << p2 << p3 << p4 << p5 << p6;
        }

        template<class T1, class T2, class T3, class T4, class T5, class T6, class T7>
        builder(T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7)
        {
            stream << p1 << p2 << p3 << p4 << p5 << p6 << p7;
        }
        template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8>
        builder(T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8)
        {
            stream << p1 << p2 << p3 << p4 << p5 << p6 << p7 << p8;
        }
        template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9>
        builder(T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8, T9 p9)
        {
            stream << p1 << p2 << p3 << p4 << p5 << p6 << p7 << p8 << p9;
        }
        template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10>
        builder(T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8, T9 p9, T10 p10)
        {
            stream << p1 << p2 << p3 << p4 << p5 << p6 << p7 << p8 << p9 << p10;
        }
        template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10, class T11>
        builder(T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8, T9 p9, T10 p10, T11 p11)
        {
            stream << p1 << p2 << p3 << p4 << p5 << p6 << p7 << p8 << p9 << p10 << p11;
        }
        template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10, class T11, class T12>
        builder(T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8, T9 p9, T10 p10, T11 p11, T12 p12)
        {
            stream << p1 << p2 << p3 << p4 << p5 << p6 << p7 << p8 << p9 << p10 << p11 << p12;
        }
        template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10, class T11, class T12, class T13>
        builder(T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8, T9 p9, T10 p10, T11 p11, T12 p12, T13 p13)
        {
            stream << p1 << p2 << p3 << p4 << p5 << p6 << p7 << p8 << p9 << p10 << p11 << p12 << p13;
        }
        template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10, class T11, class T12, class T13, class T14>
        builder(T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8, T9 p9, T10 p10, T11 p11, T12 p12, T13 p13, T14 p14)
        {
            stream << p1 << p2 << p3 << p4 << p5 << p6 << p7 << p8 << p9 << p10 << p11 << p12 << p13 << p14;
        }
        template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10, class T11, class T12, class T13, class T14, class T15>
        builder(T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8, T9 p9, T10 p10, T11 p11, T12 p12, T13 p13, T14 p14, T15 p15)
        {
            stream << p1 << p2 << p3 << p4 << p5 << p6 << p7 << p8 << p9 << p10 << p11 << p12 << p13 << p14 << p15;
        }
        template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10, class T11, class T12, class T13, class T14, class T15, class T16>
        builder(T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8, T9 p9, T10 p10, T11 p11, T12 p12, T13 p13, T14 p14, T15 p15, T16 p16)
        {
            stream << p1 << p2 << p3 << p4 << p5 << p6 << p7 << p8 << p9 << p10 << p11 << p12 << p13 << p14 << p15 << p16;
        }

        template<class T1>
        static used_string
            build(T1 p1)
        {
            return (used_string)builder(p1);
        }


        template<class T1, class T2>
        static used_string
            build(T1 p1, T2 p2)
        {
            return (used_string)builder(p1, p2);
        }

        template<class T1, class T2, class T3>
        static used_string
            build(T1 p1, T2 p2, T3 p3)
        {
            return (used_string)builder(p1, p2, p3);
        }

        template<class T1, class T2, class T3, class T4>
        static used_string
            build(T1 p1, T2 p2, T3 p3, T4 p4)
        {
            return (used_string)builder(p1, p2, p3, p4);
        }

        template<class T1, class T2, class T3, class T4, class T5>
        static used_string
            build(T1 p1, T2 p2, T3 p3, T4 p4, T5 p5)
        {
            return (used_string)builder(p1, p2, p3, p4, p5);
        }

        template<class T1, class T2, class T3, class T4, class T5, class T6>
        static used_string
            build(T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6)
        {
            return (used_string)builder(p1, p2, p3, p4, p5, p6);
        }

        template<class T1, class T2, class T3, class T4, class T5, class T6, class T7>
        static used_string
            build(T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7)
        {
            return (used_string)builder(p1, p2, p3, p4, p5, p6, p7);
        }

        template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8>
        static used_string
            build(T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8)
        {
            return (used_string)builder(p1, p2, p3, p4, p5, p6, p7, p8);
        }

        template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9>
        static used_string
            build(T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8, T9 p9)
        {
            return (used_string)builder(p1, p2, p3, p4, p5, p6, p7, p8, p9);
        }

        template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10>
        static used_string
            build(T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8, T9 p9, T10 p10)
        {
            return (used_string)builder(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10);
        }
        template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10, class T11>
        static used_string
            build(T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8, T9 p9, T10 p10, T11 p11)
        {
            return (used_string)builder(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11);
        }

        template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10, class T11, class T12>
        static used_string
            build(T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8, T9 p9, T10 p10, T11 p11, T12 p12)
        {
            return (used_string)builder(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12);
        }
        template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10, class T11, class T12, class T13>
        static used_string
            build(T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8, T9 p9, T10 p10, T11 p11, T12 p12, T13 p13)
        {
            return (used_string)builder(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, p13);
        }
        template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10, class T11, class T12, class T13, class T14>
        static used_string
            build(T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8, T9 p9, T10 p10, T11 p11, T12 p12, T13 p13, T14 p14)
        {
            return (used_string)builder(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, p13, p14);
        }
        template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10, class T11, class T12, class T13, class T14, class T15>
        static used_string
            build(T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8, T9 p9, T10 p10, T11 p11, T12 p12, T13 p13, T14 p14, T15 p15)
        {
            return (used_string)builder(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, p13, p14, p15);
        }
        template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10, class T11, class T12, class T13, class T14, class T15, class T16>
        static used_string
            build(T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8, T9 p9, T10 p10, T11 p11, T12 p12, T13 p13, T14 p14, T15 p15, T16 p16)
        {
            return (used_string)builder(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, p13, p14, p15, p16);
        }

    };

    typedef builder<char> strBuilder;
    typedef builder<wchar_t> strBuilderW;

    class CLocalAllocGuard
    {
        void * h_;
        CLocalAllocGuard(const CLocalAllocGuard&);
        CLocalAllocGuard& operator=(const CLocalAllocGuard&);
    public:
        explicit CLocalAllocGuard(void * h)
            :h_(h){}
        ~CLocalAllocGuard()
        {
            if(h_) LocalFree(h_); 
        }
        void * release()
        {
            void * hRes = h_;
            h_ = 0;
            return hRes;
        }
    };

    inline std::string FormatError(DWORD status, DWORD dwLanguageId = MAKELANGID(LANG_ENGLISH,SUBLANG_ENGLISH_US) )
    {
        LPVOID lpMsgBuf;
        if (DWORD dwSize = FormatMessageA(
            FORMAT_MESSAGE_ALLOCATE_BUFFER |
            FORMAT_MESSAGE_FROM_SYSTEM |
            FORMAT_MESSAGE_IGNORE_INSERTS,
            NULL,
            status,
            dwLanguageId, // Default language
            (LPSTR) &lpMsgBuf,
            0,
            NULL ))
        {
            utils::CLocalAllocGuard guard( lpMsgBuf );
            if(dwSize < 2) return "";
            return std::string((char*)lpMsgBuf,(char*)lpMsgBuf+dwSize - 2);
        }
        else
        {
            return strBuilder("Can't format message from error code = ", status);
        }
    }

    class CWin32Exception:public std::runtime_error
    {
        DWORD m_lastError;
    public:
        explicit CWin32Exception(const std::string & str, DWORD lastError)
            : std::runtime_error( str ), m_lastError( lastError )
        {

        }
        DWORD GetErrorCode() const
        {
            return m_lastError;
        }
    };

}

#endif //__CMN_EXCEPTION__