#ifndef __C_FILE__
#define __C_FILE__

#include <Windows.h>
#include <iostream>
#include <string>

namespace utils
{
    class CFile
    {
        HANDLE m_handle;

        CFile(const CFile & );
        CFile & operator = (const CFile&);

    public:
        CFile();
        CFile(const char * pFullName);
        CFile(const wchar_t * pFullName);
        CFile(const std::wstring & fullname, DWORD dwDesiredAccess, DWORD dwShareAccess, DWORD dwDisposition, DWORD dwFlagsAndAttributes);
        ~CFile();
 
        void Init(HANDLE handle);
        void Init(const std::string & fullname);
        void Init(const std::wstring & fullname);
        void InitCustom(const std::wstring & fullname, DWORD dwDesiredAccess, 
                                                       DWORD dwShareAccess, 
                                                       DWORD dwDisposition, 
                                                       DWORD dwFlagsAndAttributes);

        void Write(const void * pData, DWORD dwSize);
        void ReadExact(void * pData, DWORD dwSize);
        DWORD Read(void * pData, DWORD dwSize);

        HANDLE getHandle();
        void Close();
    };
}

#endif // __C_FILE__