#include "cmnString.h"

namespace utils
{
    std::string wstring2string(const std::wstring &from)
    {
        std::vector<char> res;
        wchar2str_unthrowable(from.c_str(), from.size(), &res);
        return res.empty()?"":&res[0];
    }

    std::string wstring2string(const wchar_t* from, size_t size)
    {
        std::vector<char> res;
        wchar2str_unthrowable(from, size, &res);
        return res.empty()?"":&res[0];
    }

    std::wstring string2wstring(const std::string &from)
    {
        std::vector<wchar_t> res;
        char2wstr_unthrowable(from.c_str(), from.size(), &res);
        return res.empty()?L"":&res[0];
    }

    std::wstring string2wstring(const char* from, size_t size)
    {
        std::vector<wchar_t> res;
        char2wstr_unthrowable(from, size, &res);
        return res.empty()?L"":&res[0];
    }
}