#include <tchar.h>

#include "cmnFile.h"
#include "cmnAes.h"
#include "cmnException.h"

#define CRYPT_TEMP_EXT L".!mp"
#define FILE_BUFFER_SIZE 1048576
#define CRYPT_AES_KEY "key for example"

std::wstring CreateTemporaryFileName ( const std::wstring& wstrFileSrc )
{
    return wstrFileSrc + CRYPT_TEMP_EXT;

    std::wstring wstrFileName (wstrFileSrc);
    std::wstring wstrFileTmp;

    std::wstring::size_type posPath = wstrFileName.rfind ( L'\\' );
    if ( posPath != std::wstring::npos )
    {
        wstrFileName = wstrFileName.substr ( posPath + 1 );
    }

    std::wstring::size_type posExt = wstrFileName.rfind ( L'.' );
    if ( posExt == std::wstring::npos )
    {
        wstrFileTmp = wstrFileSrc + CRYPT_TEMP_EXT;
    }
    else
    {
        wstrFileTmp = wstrFileSrc.substr ( 0, posPath + posExt + 1 ) + CRYPT_TEMP_EXT;
    }

    return wstrFileTmp;
}

int wmain ( int argc, wchar_t* argv[] )
{
    if ( argc != 2 )
    {
        std::cout << "Using example : .exe <filename to crypt>\n";
        return 0;
    }

    try 
    {
        utils::CFile srcFile ( argv[1] );

        std::wstring wstrFileSrc (argv[1]);
        std::wstring wstrFileTmp ( CreateTemporaryFileName (wstrFileSrc) );

        utils::CFile tmpFile ( wstrFileTmp.c_str (), 
                               GENERIC_READ | GENERIC_WRITE,
                               0,
                               CREATE_ALWAYS,
                               FILE_ATTRIBUTE_NORMAL );
        utils::CAes aesCipher;

        utils::CSecurityKey aesExmapleKey ( std::vector< char > (1) );
        utils::InitializeAesKey ( (const unsigned char*)CRYPT_AES_KEY, sizeof(CRYPT_AES_KEY) * 8, &aesExmapleKey );

        std::vector< char > buffer ( FILE_BUFFER_SIZE );
        DWORD dwRead = 0;
        do
        {
            dwRead = srcFile.Read ( &buffer[0], FILE_BUFFER_SIZE );
            aesCipher.EncryptECB ( &buffer[0], &buffer[0], dwRead, &aesExmapleKey );
            tmpFile.Write ( &buffer[0], dwRead );

        } while ( dwRead == FILE_BUFFER_SIZE );

        srcFile.Close ();
        tmpFile.Close ();

        if ( !MoveFileEx ( wstrFileTmp.c_str (), wstrFileSrc.c_str (), MOVEFILE_REPLACE_EXISTING ) )
        {
            throw utils::CWin32Exception ( "MoveFileEx failed", GetLastError () );
        }

    } catch ( const std::exception& ex ) {

        std::cout << "Example failed : " << ex.what () << "\n";
        return 0;
    }

    std::cout << "Crypting successful\n";
    return 0;
}